## rehex 0.63.4

=== Makefile ===
# Reverse Engineer's Hex Editor
# Copyright (C) 2017-2024 Daniel Collins <solemnwarning@solemnwarning.net>
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License version 2 as published by
# the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
# more details.
#
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 51
# Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

# Returns the first of $(1) or $(2) which is defined in the pkg-config
# database, or errors if neither are.
pkg-select-ab = $\
	$(if $(filter yes,$(shell pkg-config --exists $(1) && echo yes)),$(1),$\
		$(if $(filter yes,$(shell pkg-config --exists $(2) && echo yes)),$(2),$\
			$(error Could not find $(1) or $(2) using pkg-config)))

LUA          ?= lua
WX_CONFIG    ?= wx-config
BOTAN_PKG    ?= $(call pkg-select-ab,botan-3,botan-2)
CAPSTONE_PKG ?= capstone
JANSSON_PKG  ?= jansson
LUA_PKG      ?= $(call pkg-select-ab,lua5.3,lua)
JQ           ?= jq

EXE ?= rehex
EMBED_EXE ?= ./tools/embed
TEST_EXE ?= ./tests/all-tests
GTKCONFIG_EXE ?= ./tools/gtk-config
HELP_TARGET ?= help/rehex.htb

DEFAULT_EXE_TARGET  ?= $(EXE)
DEFAULT_TEST_TARGET ?= $(TEST_EXE)

# Wrapper around the $(shell) function that aborts the build if the command
# exits with a nonzero status.
shell-or-die = $\
	$(eval sod_out := $$(shell $(1); echo $$$$?))$\
	$(if $(filter 0,$(lastword $(sod_out))),$\
		$(wordlist 1, $(shell echo $$(($(words $(sod_out)) - 1))), $(sod_out)),$\
		$(error $(1) exited with status $(lastword $(sod_out))))

# Check if we are building target(s) that don't need to compile anything and
# skip fetching compiler flags from wx-config/pkg-config/etc if so, this avoids
# having to have our dependencies on build hosts that are going to use a chroot
# or other container for doing the actual build.

NONCOMPILE_TARGETS=clean distclean dist

need_compiler_flags ?= 1
ifneq ($(MAKECMDGOALS),)
	ifeq ($(filter-out $(NONCOMPILE_TARGETS),$(MAKECMDGOALS)),)
		need_compiler_flags=0
	endif
endif

ifeq ($(BUILD_HELP),)
	BUILD_HELP=1
endif

ifeq ($(BUILD_HELP),0)
	HELP_TARGET :=
else
	HELP_CFLAGS := -DBUILD_HELP
	HELP_LIBS := html
endif

ifeq ($(need_compiler_flags),1)
	WX_CXXFLAGS ?= $(call shell-or-die,$(WX_CONFIG) --cxxflags base core aui propgrid adv net $(HELP_LIBS))
	WX_LIBS     ?= $(call shell-or-die,$(WX_CONFIG) --libs     base core aui propgrid adv net $(HELP_LIBS))
	
	BOTAN_CFLAGS ?= $(call shell-or-die,pkg-config $(BOTAN_PKG) --cflags)
	BOTAN_LIBS   ?= $(call shell-or-die,pkg-config $(BOTAN_PKG) --libs)
	
	CAPSTONE_CFLAGS ?= $(call shell-or-die,pkg-config $(CAPSTONE_PKG) --cflags)
	CAPSTONE_LIBS   ?= $(call shell-or-die,pkg-config $(CAPSTONE_PKG) --libs)
	
	JANSSON_CFLAGS ?= $(call shell-or-die,pkg-config $(JANSSON_PKG) --cflags)
	JANSSON_LIBS   ?= $(call shell-or-die,pkg-config $(JANSSON_PKG) --libs)
	
	LUA_CFLAGS ?= $(call shell-or-die,pkg-config $(LUA_PKG) --cflags)
	LUA_LIBS   ?= $(call shell-or-die,pkg-config $(LUA_PKG) --libs)
	
	GTK_CFLAGS = $$($(GTKCONFIG_EXE) --cflags)
	GTK_LIBS   = $$($(GTKCONFIG_EXE) --libs)
	
	ifeq ($(BOTAN_PKG),botan-3)
		CXXSTD ?= -std=c++20
	else
		CXXSTD ?= -std=c++11
	endif
endif

BASE_CFLAGS := -Wall

DEBUG_CFLAGS   := -ggdb
RELEASE_CFLAGS := -g -O2 -DNDEBUG
PROFILE_CFLAGS := $(RELEASE_CFLAGS) -DREHEX_PROFILE

ifeq ($(BUILD_TYPE),)
	BUILD_TYPE := release
endif

ifeq ($(BUILD_TYPE),release)
	BASE_CFLAGS += $(RELEASE_CFLAGS)
else
	ifeq ($(BUILD_TYPE),debug)
		BASE_CFLAGS += $(DEBUG_CFLAGS)
	else
		ifeq ($(BUILD_TYPE),profile)
			BASE_CFLAGS += $(PROFILE_CFLAGS)
		else
			X := $(error unknown BUILD_TYPE '$(BUILD_TYPE)' (should be release, debug or profile))
		endif
	endif
endif

CFLAGS          := $(BASE_CFLAGS) -std=c99   -I. -Iinclude/ -IwxLua/modules/ -IwxFreeChart/include/                       $(HELP_CFLAGS) $(BOTAN_CFLAGS) $(CAPSTONE_CFLAGS) $(JANSSON_CFLAGS) $(LUA_CFLAGS) $(CFLAGS)
CXXFLAGS_NO_GTK := $(BASE_CFLAGS) $(CXXSTD) -I. -Iinclude/ -IwxLua/modules/ -IwxFreeChart/include/ -DwxOVERRIDE=override  $(HELP_CFLAGS) $(BOTAN_CFLAGS) $(CAPSTONE_CFLAGS) $(JANSSON_CFLAGS) $(LUA_CFLAGS) $(WX_CXXFLAGS) $(CXXFLAGS)
CXXFLAGS        := $(BASE_CFLAGS) $(CXXSTD) -I. -Iinclude/ -IwxLua/modules/ -IwxFreeChart/include/ -DwxOVERRIDE=override  $(HELP_CFLAGS) $(BOTAN_CFLAGS) $(CAPSTONE_CFLAGS) $(JANSSON_CFLAGS) $(LUA_CFLAGS) $(WX_CXXFLAGS) $(GTK_CFLAGS) $(CXXFLAGS)

uname_S := $(shell uname -s 2>/dev/null)
ifeq ($(uname_S),FreeBSD)
	LDLIBS += -liconv
endif
ifeq ($(uname_S),OpenBSD)
	LDLIBS += -liconv
endif

LDLIBS := -lunistring $(WX_LIBS) $(GTK_LIBS) $(BOTAN_LIBS) $(CAPSTONE_LIBS) $(JANSSON_LIBS) $(LUA_LIBS) $(LDLIBS)

# Define this for releases
# NOTE: This *MUST* be of the form a.b.c where each component is an integer to fit the format of
# macOS version numbers and Windows version info resources.
VERSION := 0.63.4

ifdef VERSION
	LONG_VERSION := Version $(VERSION)
else
	# Check if we are actually in a git checkout before trying to get the
	# commit hash with `git log`, else we blow up in a git-archive export.
	
	ifneq ($(wildcard .git/*),)
		GIT_COMMIT_SHA ?= $(call shell-or-die,git log -1 --format="%H")
	else
		GIT_COMMIT_SHA ?= UNKNOWN
	endif
	
	GIT_COMMIT_TIME ?= $(call shell-or-die,git log -1 --format="%ct")
	
	VERSION      := 850f8d79d8c8b3a87be5ebbdc9abf1b214bd5e3f
	LONG_VERSION := Snapshot 850f8d79d8c8b3a87be5ebbdc9abf1b214bd5e3f
endif

DEPDIR := .d
DEPPRE = @mkdir -p "$(dir $(DEPDIR)/$@.Td)"
DEPFLAGS = -MT $@ -MMD -MP -MF $(DEPDIR)/$@.Td
DEPPOST = @mv -f $(DEPDIR)/$@.Td $(DEPDIR)/$@.d && touch $@

WXLUA_BINDINGS := wxLua/bindings/.done

.PHONY: all
all: $(EXE)

# Stop Make from deleting intermediate files at-will. Some intermediates (e.g. resources) are used
# by multiple targets (all and test) and so they should persist. Others are generated as a
# side-effect of another target (wxLua bindings) so Make cannot properly track how to build them
# when it needs to recreate them later.
.SECONDARY:

.PHONY: check
check: $(TEST_EXE)
	$(TEST_EXE)
	
	for p in $(PLUGINS); \
	do \
		$(MAKE) -C plugins/$${p} LUA=$(LUA) check || exit $$?; \
	done

.PHONY: clean
clean:
	rm -f res/ascii16.c   res/ascii16.h \
	      res/ascii24.c   res/ascii24.h \
	      res/ascii32.c   res/ascii32.h \
	      res/ascii48.c   res/ascii48.h \
	      res/diff_fold16.c res/diff_fold16.h \
	      res/diff_fold24.c res/diff_fold24.h \
	      res/diff_fold32.c res/diff_fold32.h \
	      res/diff_fold48.c res/diff_fold48.h \
	      res/dock_bottom.c res/dock_bottom.h \
	      res/dock_left.c   res/dock_left.h \
	      res/dock_right.c  res/dock_right.h \
	      res/dock_top.c    res/dock_top.h \
	      res/icon16.c    res/icon16.h \
	      res/icon32.c    res/icon32.h \
	      res/icon48.c    res/icon48.h \
	      res/icon64.c    res/icon64.h \
	      res/icon128.c   res/icon128.h \
	      res/license.c   res/license.h   res/license.done \
	      res/offsets16.c res/offsets16.h \
	      res/offsets24.c res/offsets24.h \
	      res/offsets32.c res/offsets32.h \
	      res/offsets48.c res/offsets48.h \
	      res/shortcut48.c  res/shortcut48.h \
	      res/spinner24.c   res/spinner24.h
	
	rm -f $(filter-out %.$(BUILD_TYPE).o,$(APP_OBJS))
	rm -f $(patsubst %.$(BUILD_TYPE).o,%.debug.o,$(filter %.$(BUILD_TYPE).o,$(APP_OBJS)))
	rm -f $(patsubst %.$(BUILD_TYPE).o,%.release.o,$(filter %.$(BUILD_TYPE).o,$(APP_OBJS)))
	rm -f $(patsubst %.$(BUILD_TYPE).o,%.profile.o,$(filter %.$(BUILD_TYPE).o,$(APP_OBJS)))
	rm -f $(EXE)
	
	rm -f $(filter-out %.$(BUILD_TYPE).o,$(TEST_OBJS))
	rm -f $(patsubst %.$(BUILD_TYPE).o,%.debug.o,$(filter %.$(BUILD_TYPE).o,$(TEST_OBJS)))
	rm -f $(patsubst %.$(BUILD_TYPE).o,%.release.o,$(filter %.$(BUILD_TYPE).o,$(TEST_OBJS)))
	rm -f $(patsubst %.$(BUILD_TYPE).o,%.profile.o,$(filter %.$(BUILD_TYPE).o,$(TEST_OBJS)))
	rm -f $(TEST_EXE)
	
	rm -f $(EMBED_EXE)
	rm -f $(GTKCONFIG_EXE)
	
	grep -r "generated by genwxbind.lua" wxLua/ --exclude=genwxbind.lua | cut -d: -f1 | sort | uniq | xargs -r rm
	rm -f $(WXLUA_BINDINGS)
	
	rm -f src/lua-bindings/rehex_bind.done src/lua-bindings/rehex_bind.cpp src/lua-bindings/rehex_bind.h
	rm -f src/lua-plugin-preload.done src/lua-plugin-preload.c src/lua-plugin-preload.h

.PHONY: distclean
distclean: clean

WXLUA_OBJS := \
	wxLua/modules/wxlua/bit.$(BUILD_TYPE).o \
	wxLua/modules/wxlua/lbitlib.$(BUILD_TYPE).o \
	wxLua/modules/wxlua/wxlbind.$(BUILD_TYPE).o \
	wxLua/modules/wxlua/wxlcallb.$(BUILD_TYPE).o \
	wxLua/modules/wxlua/wxllua.$(BUILD_TYPE).o \
	wxLua/modules/wxlua/wxlobject.$(BUILD_TYPE).o \
	wxLua/modules/wxlua/wxlstate.$(BUILD_TYPE).o \
	wxLua/modules/wxlua/wxlua_bind.$(BUILD_TYPE).o

WXBIND_OBJS := \
	wxLua/modules/wxbind/src/wxadv_bind.$(BUILD_TYPE).o \
	wxLua/modules/wxbind/src/wxadv_wxladv.$(BUILD_TYPE).o \
	wxLua/modules/wxbind/src/wxaui_bind.$(BUILD_TYPE).o \
	wxLua/modules/wxbind/src/wxbase_base.$(BUILD_TYPE).o \
	wxLua/modules/wxbind/src/wxbase_bind.$(BUILD_TYPE).o \
	wxLua/modules/wxbind/src/wxbase_config.$(BUILD_TYPE).o \
	wxLua/modules/wxbind/src/wxbase_data.$(BUILD_TYPE).o \
	wxLua/modules/wxbind/src/wxbase_datetime.$(BUILD_TYPE).o \
	wxLua/modules/wxbind/src/wxbase_file.$(BUILD_TYPE).o \
	wxLua/modules/wxbind/src/wxcore_appframe.$(BUILD_TYPE).o \
	wxLua/modules/wxbind/src/wxcore_bind.$(BUILD_TYPE).o \
	wxLua/modules/wxbind/src/wxcore_clipdrag.$(BUILD_TYPE).o \
	wxLua/modules/wxbind/src/wxcore_controls.$(BUILD_TYPE).o \
	wxLua/modules/wxbind/src/wxcore_core.$(BUILD_TYPE).o \
	wxLua/modules/wxbind/src/wxcore_defsutils.$(BUILD_TYPE).o \
	wxLua/modules/wxbind/src/wxcore_dialogs.$(BUILD_TYPE).o \
	wxLua/modules/wxbind/src/wxcore_event.$(BUILD_TYPE).o \
	wxLua/modules/wxbind/src/wxcore_gdi.$(BUILD_TYPE).o \
	wxLua/modules/wxbind/src/wxcore_geometry.$(BUILD_TYPE).o \
	wxLua/modules/wxbind/src/wxcore_graphics.$(BUILD_TYPE).o \
	wxLua/modules/wxbind/src/wxcore_help.$(BUILD_TYPE).o \
	wxLua/modules/wxbind/src/wxcore_image.$(BUILD_TYPE).o \
	wxLua/modules/wxbind/src/wxcore_mdi.$(BUILD_TYPE).o \
	wxLua/modules/wxbind/src/wxcore_menutool.$(BUILD_TYPE).o \
	wxLua/modules/wxbind/src/wxcore_picker.$(BUILD_TYPE).o \
	wxLua/modules/wxbind/src/wxcore_print.$(BUILD_TYPE).o \
	wxLua/modules/wxbind/src/wxcore_sizer.$(BUILD_TYPE).o \
	wxLua/modules/wxbind/src/wxcore_windows.$(BUILD_TYPE).o \
	wxLua/modules/wxbind/src/wxcore_wxlcore.$(BUILD_TYPE).o \
	wxLua/modules/wxbind/src/wxpropgrid_bind.$(BUILD_TYPE).o

WXFREECHART_OBJS := \
	wxFreeChart/src/areadraw.$(BUILD_TYPE).o \
	wxFreeChart/src/art.$(BUILD_TYPE).o \
	wxFreeChart/src/axis/axis.$(BUILD_TYPE).o \
	wxFreeChart/src/axis/categoryaxis.$(BUILD_TYPE).o \
	wxFreeChart/src/axis/compdateaxis.$(BUILD_TYPE).o \
	wxFreeChart/src/axis/dateaxis.$(BUILD_TYPE).o \
	wxFreeChart/src/axis/juliandateaxis.$(BUILD_TYPE).o \
	wxFreeChart/src/axis/labelaxis.$(BUILD_TYPE).o \
	wxFreeChart/src/axis/logarithmicnumberaxis.$(BUILD_TYPE).o \
	wxFreeChart/src/axis/numberaxis.$(BUILD_TYPE).o \
	wxFreeChart/src/axisplot.$(BUILD_TYPE).o \
	wxFreeChart/src/bars/barplot.$(BUILD_TYPE).o \
	wxFreeChart/src/bars/barrenderer.$(BUILD_TYPE).o \
	wxFreeChart/src/category/categorydataset.$(BUILD_TYPE).o \
	wxFreeChart/src/category/categoryrenderer.$(BUILD_TYPE).o \
	wxFreeChart/src/category/categorysimpledataset.$(BUILD_TYPE).o \
	wxFreeChart/src/chart.$(BUILD_TYPE).o \
	wxFreeChart/src/chartpanel.$(BUILD_TYPE).o \
	wxFreeChart/src/chartsplitpanel.$(BUILD_TYPE).o \
	wxFreeChart/src/colorscheme.$(BUILD_TYPE).o \
	wxFreeChart/src/crosshair.$(BUILD_TYPE).o \
	wxFreeChart/src/dataset.$(BUILD_TYPE).o \
	wxFreeChart/src/gantt/ganttdataset.$(BUILD_TYPE).o \
	wxFreeChart/src/gantt/ganttplot.$(BUILD_TYPE).o \
	wxFreeChart/src/gantt/ganttrenderer.$(BUILD_TYPE).o \

=== debian/changelog ===
rehex (0.63.4-0~ubuntu2510) questing; urgency=low

  * Save selected value colour map in default view (#268).

  * Fix blurry text/icons when using DPI scaling under moden Windows (#267).

  * Fix crash when pressing enter in search for value and search for byte
    sequence dialogs (#272).

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Sun, 23 Nov 2025 15:04:56 +0000

rehex (0.63.3-0~ubuntu2510) questing; urgency=low

  * Add option to change bitmap visualisation image background to a
    chosen colour (#258).

  * Copy and save full-size image with alpha channel from bitmap
    visualisation instead of the preview image.

  * Add light icons for use with dark themes to bitmap visualisation and
    histogram views (#262).

  * Add search history to text search dialog (#260).

  * Work around crash with large bitmap previews on Linux (#263).

  * Improve performance of bitmap visualisation.

  * Added missing MOS6502 and Motorola 6800/68k disassembly support for
    x86 Windows (#264).

  * Added RISC-V and WASM disassembly support (where supported by host
    Capstone library).

  * Implement tool panel detaching/docking under Wayland (#252).

  * Update detached tool window title when tab is changed.

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Wed, 15 Oct 2025 23:03:18 +0100

rehex (0.63.2-0~ubuntu2504) plucky; urgency=low

  * Add missing file required for binary template support.

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Sun, 13 Jul 2025 15:57:02 +0100

rehex (0.63.1-0~ubuntu2504) plucky; urgency=low

  * Improve performance of templates that declare large numbers of file
    variables.

  * Fix selecting the byte range encapsulated by a comment (#255).

  * Add "Jump to end" command to comments panel context menu (#254).

  * Improve rendering performance and UI responsiveness, particularly
    when a large number of colours are in use (#257).

  * Fix searching within a range.

  * Default to selection when a range is selected prior to opening
    search dialog (#256).

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Sun, 13 Jul 2025 15:22:02 +0100

rehex (0.63.0-0~ubuntu2504) plucky; urgency=low

  * Add non-modal "Jump to offset" dialog option (#242).

  * Add "Repeat last 'Jump to offset'" command (#242).

  * Add "Visual Scrollbar" for high-level overview of file contents.

  * Add "Data visualisation" tool for overfiew of file/selection
    contents (#230).

  * Add metadata import/export commands (#248).

  * Fix crash when <charset = "US-ASCII"> is specified for a file variable
    in a template (#246).

  * Add highlight functions to scripting API and template language (#247).

  * Fix memory leaks in bitmap preview tool and metadata serialisation.

  * Suspend scanning for strings when the strings tool is hidden.

  * Fix the continue/reset buttons in the strings tool not working
    correctly.

  * Fix horizontal scroll position being set out-of-range when the window is
    resized in some situations.

  * Fix bitmap preview tool not following cursor correctly (#244).

  * Allow detaching tool panels to floating windows or docking them to any
    side of the main window (#229).

  * Reduce unnecessary padding in decimal offsets (#235).

  * Fix range selection input for checksum/histogram on macOS.

  * Fix selection being prematurely initiated when the mouse is clicked
    over file data.

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Thu, 12 Jun 2025 11:47:37 +0100

rehex (0.62.0-0~ubuntu2504) plucky; urgency=low

  * Add bit array data type (#167).

  * Allow selecting and setting comments/highlights/types on
    bit-sized/aligned quantities, not just byte-aligned (#155).

  * Allow defining arbitrary integer types, up to 64 bits wide (#215).

  * Allow colouring data by byte value (#223).

  * Allow changing/defining custom highlight colours and assigning
    labels to them (#227).

  * Use dimmer highlight colours for dark colour schemes (#227).

  * Save highlight colours/labels per-file (#60).

  * Allow changing keyboard shortcuts (#226).

  * Add Shift+Enter shortcut for "OK" in the comment dialog (#226).

  * Display offset in both decimal and hexadecimal in status bar (#228).

  * Fix handling of relative paths specified on the command line when
    opening in an existing instance (#237).

  * Allow navigating hex data by nibbles rather than bytes (#58).

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Fri, 02 May 2025 01:11:13 +0100

rehex (0.61.1-0~ubuntu2404) noble; urgency=low

  * Compare data from correct file offsets when "Collapse matches" option is
    enabled in compare window (#224).

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Sun, 05 May 2024 19:54:32 +0100

=== debian/control ===
Source: rehex
Priority: extra
Maintainer: Daniel Collins <solemnwarning@solemnwarning.net>
Build-Depends:
 debhelper (>= 9)
Build-Depends-Arch:
 libbotan-2-dev,
 libcapstone-dev,
 libgtk-3-dev,
 libjansson-dev,
 libwxgtk3.2-dev,
 liblua5.3-dev,
 libtemplate-perl,
 libunistring-dev,
 lua-busted,
 lua5.3,
 pkg-config,
 xauth,
 xvfb,
 wx3.2-headers,
 zip,
 zlib1g-dev
Standards-Version: 3.9.4
Section: editors
Homepage: https://github.com/solemnwarning/rehex/

Package: rehex
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 libbotan-2-19,
 libcapstone5,
 libjansson4,
 liblua5.3-0,
 libunistring5,
 libwxgtk3.2-1t64,
 zlib1g
Description: Reverse Engineers' Hex Editor
